﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;

namespace WindowsFormsApplication19
{
    public partial class Form1 : Form
    {
        CheckEditor checkEditor;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.checkEditor = new CheckEditor();
            checkEditor.CheckAlign = ContentAlignment.MiddleCenter;
            checkEditor.DataFilter = new CheckBoxDataFilter();

            DataTable dt = new DataTable();
            dt.Columns.Add("CheckBox", typeof(bool));

            dt.Rows.Add(new object[] {true});
            dt.Rows.Add(new object[] {null});
            dt.Rows.Add(new object[] {false});

            this.ultraGrid1.SetDataBinding(dt, null);

            this.uiElementViewerDialog1.Show(this, new Point(this.Bounds.Right, this.Bounds.Top));
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {            
            e.Layout.Bands[0].Columns[0].Editor = this.checkEditor;
        }

        public class CheckBoxDataFilter : IEditorDataFilter
        {
            object IEditorDataFilter.Convert(EditorDataFilterConvertArgs conversionArgs)
            {
                switch (conversionArgs.Direction)
                {
                    case ConversionDirection.OwnerToEditor:
                        if (conversionArgs.Value is DBNull ||
                            conversionArgs.Value == null)
                        {
                            conversionArgs.Handled = true;
                            return false;
                        }

                        break;
                }

                return conversionArgs.Value;
            }
        }

    }


}
